/*
 * HTTPcat, on GNU license.
 * Author: Andrzej Godziuk (GDR!)
 * http://www.GDR.w.pl/
 */


enum reqmode{REQ_SIMPLE10=0,REQ_SIMPLE11,REQ_HEAD10,REQ_IE5,REQ_IE6,REQ_OPERA,REQ_MOZILLA,REQ_FGET,REQ_V3,REQ_IB};

struct reqdata {
	char *hostname;
	int port;
	char *request;
	HWND hStat;
	HWND hWnd;
};

void makerequest(char *buf, char *path, int port, char *host, char *useragent, int mode);
void idsend(HWND hwnd);

void gettext(HWND hwnd, int resid, char **request)
{
	HWND hCtl;
	int buflen;

	hCtl = GetDlgItem(hwnd, resid);
	buflen = GetWindowTextLength(hCtl);
	*request = malloc(buflen+1024);
	if(!(*request)) MessageBox(g_hwnd, "Ran out of memory!", "Warning", 0);
	GetWindowText(hCtl, *request, buflen+1);

}


void getreq(char **request)
{
	HWND hCtl;
	int buflen;

	hCtl = GetDlgItem(g_hwnd, IDC_REQUEST);
	buflen = GetWindowTextLength(hCtl);
	*request = malloc(buflen+1024);
	if(!(*request)) MessageBox(g_hwnd, "Ran out of memory!", "Warning", 0);
	GetWindowText(hCtl, *request, buflen+1);

}

void getrsp(char **request)
{
	HWND hCtl;
	int buflen;

	hCtl = GetDlgItem(g_hwnd, IDC_RESPONSE);
	buflen = GetWindowTextLength(hCtl);
	*request = malloc(buflen+1024);
	if(!(*request)) MessageBox(g_hwnd, "Ran out of memory!", "Warning", 0);
	GetWindowText(hCtl, *request, buflen+1);

}

void formrequest(char *req)
{
	int len;
	len = strlen(req);
	if(len<2) return;
	if((req[len-2]=='\r') && (req[len-1]=='\n'))
	{
		if((req[len-4]=='\r') && (req[len-3]=='\n'))
		{
			return;
		}
		else
		{
			strcat(req, "\r\n");
		}
	}
	else
	{
		strcat(req, "\r\n\r\n");
	}
}

void correctrespbuf(char *s, char **dd, int len)
{
	char *d;
	int c=0, a;

	a = len;
	d = *dd;

	do
	{
		c++;
		if((*s) != '\n') *(d++) = *(s++);
		else 
		{
			if(*(s-1)=='\r')
			{
				*(d++) = *(s++);
			}
			else
			{
				*(d++) = '\r';
				*(d++) = *(s++);
			}
		}
		if(c>=a) {realloc(*dd, a+1024); a += 1023;}
	}
	while(--len);

	*d = 0;
}

void setresponse(char *resp, int len, HWND hwnd)
{
	char *b2;
	HWND hctl = GetDlgItem(hwnd, IDC_RESPONSE);

	b2 = malloc(len+10);
//	correctrespbuf(resp, &b2, len);
	memcpy(b2, resp, len);
	b2[len]=0;

	if(IsDlgButtonChecked(hwnd, IDC_SHOWRESPONSE)!=BST_CHECKED)
	{
		char *p = b2;
		do
		{
			if(!strncmp(p, "\r\n\r\n", 4)) *(p+2)=0;
		} while(*(p++));
	}

	SetWindowText(hctl, b2);

	free(b2);
}

void parseurl(char *req, char *host, int *port, char *path)
{
	char *url;
	char *p, *q;
	int urllen = 1024;
	int c=0;

	url = malloc(urllen);
	if(!url) MessageBox(0, "No memory!", "HTTPcat error", 0);

	p = strstr(req, "http://");
	if(!p) p=req;
	else p += strlen("http://");

	q=url;
	do
	{

		*(q++) = *(p++);

		if((++c) >= (urllen-20)) {realloc(url, urllen+1024); urllen += 1024;}
	} while((*p != ' ') && (*p != 0));
	*q = 0;

	p = url;

	q = host;
	do
	{
		*(q++) = *(p++);
	} while((*p != '/') && (*p != ':') && (*p != 0));
	*q = 0;

	if(*p==':')
	{
		p++;
		*port = atoi(p);
		while(*(++p)!='/');
	}
	else *port = 80;
	/*    *p == '/'    */
	
	if(*p)
	{
		q = path;
		while(*(q++) = *(p++));
	}
	else strcpy(path, "/");

	free(url);
}

int nonspaces(char *p)
{
	int i=0;

	while(*(p++)) if(!isspace(*p)) i++;
	return i;
}

void recvurl(char *url)
{
	char *host, *path, *buf;
	int port;
	HWND hCtl;

	if(nonspaces(url)==0) return;

	host = malloc(strlen(url)+2);
	path = malloc(strlen(url));
	buf = malloc(10*strlen(url)+16384);

	parseurl(url, host, &port, path);
	makerequest(buf, path, port, host, "", REQ_SIMPLE10);

	hCtl = GetDlgItem(g_hwnd, IDC_HOST);
	SetWindowText(hCtl, host);
	hCtl = GetDlgItem(g_hwnd, IDC_REQUEST);
	SetWindowText(hCtl, buf);
	sprintf(buf, "%d", port);
	hCtl = GetDlgItem(g_hwnd, IDC_PORT);
	SetWindowText(hCtl, buf);

	free(buf);
	free(path);
	free(host);
}

void getfilefromurl(char *url, char *file)
{
	char *p = strrchr(url, '/')+1;
	if(*p) strcpy(file, p);
	else strcpy(file, "index.html");
}

void getfilefromreq(char *url, char *file)
{
	char *q;
	char *p = strstr(url, "GET ") + strlen("GET ");
	while((*p) && (*p!=' ')) p++;
	q=p;
	while(*q != '/') q--;
	q++; 
	if(q<p) {strncpy(file, q, p-q); file[p-q]=0;}
	else strcpy(file, "index.html");
}

void makerequest(char *buf, char *path, int port, char *host, char *useragent, int mode)
{
	switch(mode)
	{
	case REQ_SIMPLE10:
		{
			if(strlen(useragent))
			{
				sprintf(buf, "GET %s HTTP/1.0\r\nHost: %s\r\nUser-agent: %s\r\n\r\n", path, host, useragent);
			}
			else
			{
				sprintf(buf, "GET %s HTTP/1.0\r\nHost: %s\r\n\r\n", path, host);
			}
		}
		break;
	case REQ_SIMPLE11:
		{
			if(strlen(useragent))
			{
				sprintf(buf, "GET %s HTTP/1.1\r\nHost: %s\r\nUser-agent: %s\r\n\r\n", path, host, useragent);
			}
			else
			{
				sprintf(buf, "GET %s HTTP/1.1\r\nHost: %s\r\n\r\n", path, host);
			}
		}
		break;
	case REQ_HEAD10:
		{
			if(strlen(useragent))
			{
				sprintf(buf, "HEAD %s HTTP/1.0\r\nHost: %s\r\nUser-agent: %s\r\n\r\n", path, host, useragent);
			}
			else
			{
				sprintf(buf, "HEAD %s HTTP/1.0\r\nHost: %s\r\n\r\n", path, host);
			}
		}
		break;
	case REQ_IE5:
		{
			sprintf(buf, "GET %s HTTP/1.1\r\nAccept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/x-shockwave-flash, */*\r\nAccept-Language: pl\r\nAccept-Encoding: gzip, deflate\r\nUser-Agent: Mozilla/4.0 (compatible; MSIE 5.5; Windows 98; Win 9x 4.90)\r\nHost: %s\r\nConnection: Keep-Alive\r\n\r\n", path, host);
		}
		break;
	case REQ_OPERA:
		{
			sprintf(buf, "GET %s HTTP/1.1\r\nUser-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows ME) Opera 7.21  [en]\r\nHost: %s\r\nAccept: text/html, application/xml;q=0.9, application/xhtml+xml;q=0.9, image/png, image/jpeg, image/gif, image/x-xbitmap, */*;q=0.1\r\nAccept-Language: en\r\nAccept-Charset: windows-1252, utf-8, utf-16, iso-8859-1;q=0.6, *;q=0.1\r\nAccept-Encoding: deflate, gzip, x-gzip, identity, *;q=0\r\nConnection: Keep-Alive\r\n\r\n", path, host);
		}
		break;
	case REQ_V3:
		{
			sprintf(buf, "GET %s HTTP/1.1\r\nUser-Agent: AmigaVoyager/3.4.4 (MorphOS/PPC native)\r\nHost: %s\r\nAccept-Language: en, *\r\nConnection: Keep-Alive\r\nAccept: text/html;level=3\r\nAccept: text/html;version=3.0\r\nAccept: */*\r\n\r\n", path, host);
		}
		break;
	case REQ_IB:
		{
			sprintf(buf, "GET %s HTTP/1.0\r\nUser-Agent: IBrowse/2.3 (MorphOS 1.4)\r\nAccept-Language: *\r\nHost: %s\r\nAccept: text/html;level=3\r\nAccept: text/html;version=3.0\r\nAccept: */*\r\n\r\n", path, host);
		}
		break;
	case REQ_MOZILLA:
		{
			sprintf(buf, "GET %s HTTP/1.1\r\nHost: %s\r\nUser-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.5) Gecko/20031007 Firebird/0.7\r\nAccept: text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,video/x-mng,image/png,image/jpeg,image/gif;q=0.2,*/*;q=0.1\r\nAccept-Language: en-us,en;q=0.5\r\nAccept-Encoding: gzip,deflate\r\nAccept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7\r\nKeep-Alive: 300\r\nConnection: keep-alive\r\n\r\n", path, host);
		} break;
	}
}

void saveresponse(char *resp, int len, HWND hwnd)
{
	if(IsDlgButtonChecked(hwnd, IDC_SAVERESPONSE)==BST_CHECKED)
	{
		char *p = resp;
		do
		{
			if(!strncmp(p, "\r\n\r\n", 4)) {p+=4; break;}
		} while(*(p++));
		if(*p)
		{
			char *name;
			HWND hCtl;
			int buflen;
			FILE *f;

			hCtl = GetDlgItem(hwnd, IDC_RESPONSEFILEPATH);
			buflen = GetWindowTextLength(hCtl);
			name = malloc(buflen+MAX_PATH+1);
			if(!name) MessageBox(hwnd, "Ran out of memory!", "Warning", 0);
			GetWindowText(hCtl, name, buflen+1);

			if(IsDlgButtonChecked(hwnd, IDC_AUTONAME)==BST_CHECKED);
			{
				char *req;
				char fn[MAX_PATH];

				getreq(&req);
				getfilefromreq(req, fn);
				if((strlen(name)==0) || (name[strlen(name)-1]!='\\')) strcat(name, "\\");
				strcat(name, fn);

				free(req);
			}


			f = fopen(name, "wb");
			if(!f) MessageBox(hwnd, "Couldn't open file for writing", "Error", 0);
			else
			{
				fwrite(p, len-(p-resp), 1, f);
				fclose(f);
				free(name);
			}
		}
	}

}

void setbuttons(int s)
{
	HWND h;

	h = GetDlgItem(g_hwnd, IDSEND);
	EnableWindow(h, s);

	h = GetDlgItem(g_hwnd, IDFILL);
	EnableWindow(h, s);

	h = GetDlgItem(g_hwnd, IDC_REPEATED);
	EnableWindow(h, s);

	h = GetDlgItem(g_hwnd, IDC_QFR);
	EnableWindow(h, s);

	h = GetDlgItem(g_hwnd, IDC_FOLLOW302);
	EnableWindow(h, s);

	h = GetDlgItem(g_hwnd, IDC_SAVERESPONSEHEADER);
	EnableWindow(h, s);

	h = GetDlgItem(g_hwnd, IDC_COOKIES);
	EnableWindow(h, s);

	h = GetDlgItem(g_hwnd, IDC_RESPONSEFILE);
	EnableWindow(h, s);

}

DWORD WINAPI sendthread(LPVOID ffd)
{
	struct reqdata *rd = (struct reqdata *)ffd;
	int sockfd;
	char *request = rd->request;
	char *result=0;

	formrequest(request);

	setbuttons(0);

	sockfd = fsockopen_gui(rd->hostname, rd->port, rd->hStat);
	if(sockfd)
	{
		int rlen;
		int hdonly;

		if( (IsDlgButtonChecked(rd->hWnd, IDC_SHOWRESPONSE)!=BST_CHECKED) && (IsDlgButtonChecked(rd->hWnd, IDC_SAVERESPONSE)!=BST_CHECKED) ) hdonly=1;
		else hdonly = 0;

		sendall_gui(sockfd, request, strlen(request), rd->hStat);
		rlen = recvall_gui(sockfd, &result, hdonly, rd->hStat);

		setresponse(result, rlen, rd->hWnd);
		saveresponse(result, rlen, rd->hWnd);

		closesocket(sockfd);
	}

	if(result) free(result);
	free(rd->hostname);
	free(rd->request);
	free(rd);

	setbuttons(1);
	return 0;
}


void idsend(HWND hwnd)
{
	HWND hCtl;
	char *hostname;
	char *port_a;
	char *request;
	int port;
	int buflen;
	struct reqdata *rd;

	hCtl = GetDlgItem(hwnd, IDC_HOST);
	buflen = GetWindowTextLength(hCtl);
	hostname = malloc(buflen+1);
	if(!hostname) MessageBox(hwnd, "Ran out of memory!", "Warning", 0);
	GetWindowText(hCtl, hostname, buflen+1);
	
	hCtl = GetDlgItem(hwnd, IDC_PORT);
	buflen = GetWindowTextLength(hCtl);
	port_a = malloc(buflen+1);
	if(!port_a) MessageBox(hwnd, "Ran out of memory!", "Warning", 0);
	GetWindowText(hCtl, port_a, buflen+1);
	port = atoi(port_a);

	hCtl = GetDlgItem(hwnd, IDC_REQUEST);
	buflen = GetWindowTextLength(hCtl);
	request = malloc(buflen+1024);
	if(!request) MessageBox(hwnd, "Ran out of memory!", "Warning", 0);
	GetWindowText(hCtl, request, buflen+1);
	
	rd = malloc(sizeof(struct reqdata));

	rd->hostname = hostname;
	rd->port = port;
	rd->request = request;
	rd->hStat = GetDlgItem(hwnd, IDC_STATUS);
	rd->hWnd = hwnd;

	CreateThread(0, 0, sendthread, rd, 0, (unsigned long*)&buflen);

	free(port_a);

}

void selectsavefile(HWND hwnd)
{
	OPENFILENAME ofn;
	char szFileName[MAX_PATH] = "";
	int dirmode=0;


	dirmode = (IsDlgButtonChecked(hwnd, IDC_AUTONAME)==BST_CHECKED);
	ZeroMemory(&ofn, sizeof(ofn));

	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hwnd;
	ofn.lpstrFilter = "All Files (*.*)\0*.*\0";
	ofn.lpstrFile = szFileName;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrDefExt = 0;
	ofn.Flags = OFN_EXPLORER | OFN_HIDEREADONLY | (dirmode?0:(OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST));

	if(GetSaveFileName(&ofn))
	{
		HWND hctl;

		hctl = GetDlgItem(hwnd, IDC_RESPONSEFILEPATH);
		if(dirmode)
		{
			char *p;
			p = strrchr(szFileName, '\\');
			p[1]='\0';
		}

		SetWindowText(hctl, szFileName);
	}

}

saveresponseheader(HWND hwnd)
{
	OPENFILENAME ofn;
	char szFileName[MAX_PATH] = "";

	ZeroMemory(&ofn, sizeof(ofn));

	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hwnd;
	ofn.lpstrFilter = "All Files (*.*)\0*.*\0";
	ofn.lpstrFile = szFileName;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrDefExt = 0;
	ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;

	if(GetSaveFileName(&ofn))
	{
		HWND hCtl;
		char *resp, *p;
		FILE *f;
		int buflen;

		hCtl = GetDlgItem(hwnd, IDC_RESPONSE);
		buflen = GetWindowTextLength(hCtl);
		resp = malloc(buflen+1024);
		if(!resp) MessageBox(hwnd, "Ran out of memory!", "Warning", 0);
		GetWindowText(hCtl, resp, buflen+1);

		f = fopen(szFileName, "w");
		if(!f) MessageBox(hwnd, "Couldn't open file for writing", "Error", 0);
		else
		{
			p = resp;

			while((*p) && strncmp(p, "\r\n\r\n", 4)) fputc(*(p++), f);

			fclose(f);
		}
		free(resp);

	}

}


void f302(HWND hwnd)
{
	char *rsp, *p, *q, *url;

	getrsp(&rsp);
	p = strstr(rsp, "Location: ");
	if(p)
	{
		p += strlen("Location: ");
		q=p;
		while((*q!='\r') && (*q!=' ') && (*q)) q++;
		url = malloc(50+q-p);
		strncpy(url, p, q-p);
		url[q-p]=0;

		recvurl(url);
		
		free(url);
	}
	free(rsp);
}

void passcookies(HWND hwnd)
{
	char *req, *resp, *p, *q, *cookies;
	int clen, cnum=0;

	getreq(&req);
	getrsp(&resp);

	cookies = malloc(600);
	clen=500;
	*cookies = 0;

	p = resp;
	while(q = strstr(p, "Set-Cookie: "))
	{
		char *cookie, *s;
		int nl;

		cnum++;
		p=q+strlen("Set-Cookie: ");
		while(*(q++)!=';');

		cookie = malloc((q-p)+10);
		s = cookie;
		while(p<q) *(s++)=*(p++);
		*(s-1)=0;

		nl = strlen(cookie);

		if(!strstr(cookie, "=deleted"))
		{
			realloc(cookies, clen+nl+600);
			clen += strlen(cookie)+100;

			strcat(cookies, cookie);
			strcat(cookies, "; ");
		}
		free(cookie);
	}
	if(cnum)
	{
		cookies[strlen(cookies)-2]=0;

		p = req + strlen(req);
		while(isspace(*(--p)));
		*(++p)=0;

		realloc(req, strlen(req)+strlen(cookies)+500);
		strcat(req, "\r\nCookie: ");
		strcat(req, cookies);
		strcat(req, "\r\n\r\n");
		SetDlgItemText(hwnd, IDC_REQUEST, req);
	}
	free(req);
	free(cookies);
	free(resp);

}

void hosttoip(HWND *hwnd)
{
	long ip;
	char *host, buf[2048];
	
	gettext(hwnd, IDC_HOST, &host);
	if(strlen(host))
	{
		ip = getip_gui(host, GetDlgItem(hwnd, IDC_STATUS));
		sprintf(buf, "Host name:\r\n%s\r\n\r\nIP:\r\n%s\r\n%s", host, ip2str(ip), ip?"":"(Resolve failed)");
		mydialog(buf);
	}
	free(host);
}